<?php
/*

>>>>>> CrazyStat <<<<<<
Ein komfortables, umfangreiches und kostenloses Statistik-Script mit oder ohne Counter.

Copyright (C) 2004-2006  Crazy Chrissi

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

E-Mail: christosoft4u@yahoo.de
Web: http://www.christosoft.de.vu
Version: 1.53

*** kreisdiagramm.php ***
Funktion:    erzeugt Kreisdiagramm
Aufrufbar:   nein
Eingebunden: von show_stat.php (als Bild)
*/

if(!isset($_GET["modul"])) die("Fehler beim &Uuml;bermitteln des Moduls.");

session_start();
include("config.php");
$werte=$_SESSION["modul_".$_GET["modul"]."_werte"];

$breite=90;
$hoehe=90;

$farben=$config_stat_farben;
if(!isset($werte)) $werte[]=0;

$diagramm=imagecreate($breite,$hoehe);
$hoehe--;
$breite--;
$weiss=imagecolorallocate($diagramm, 255, 255, 255);
$schwarz=imagecolorallocate($diagramm, 0, 0, 0);


imagefilledrectangle($diagramm,0,0,$breite,$hoehe,$weiss);

foreach($farben as $nummer => $farbe)
 {
 $rgb=hex2rgb($farbe);
 $farben[$nummer]=imagecolorallocate($diagramm, $rgb[0],$rgb[1],$rgb[2]);
 }

// Kreis zeichnen fuer alte GDlib
imagearc($diagramm, round($breite/2), round($hoehe/2), $breite, $hoehe, 1, 360, $schwarz);

$grauton=0;
$winkel=270;
$teil=0;
rsort($werte);

foreach($werte as $wert)
 {
 $wert=prozent($wert,$_SESSION["modul_".$_GET["modul"]."_gesamt"]);

 if(!isset($farben[$teil]))
  {
  $grauton+=20;
  if($grauton>255) $grauton=0;
  $farben[$teil]=imagecolorallocate($diagramm,$grauton,$grauton,$grauton);
  }

 if($winkel>360) $winkel-=360;
 $wert=round(($wert/100)*360);

 // Tortenstueck zeichnen
 if(is_callable("imagefilledarc"))
  {
  @$ausfuellen=imagefilledarc($diagramm, round($breite/2), round($hoehe/2), $breite, $hoehe, $winkel, $winkel+$wert, $farben[$teil],IMG_ARC_EDGED);
  }
 else
  {
  $ausfuellen=false;
  }

 if($ausfuellen!=true)
  {
  // Tortenstuecke fuer GDlib <2.0.1 zeichnen
  $radius_x1=round(round($breite/2)*cos($winkel/180*M_PI)+round($breite/2));
  $radius_y1=round(round($hoehe/2)*sin($winkel/180*M_PI)+round($hoehe/2));
  $rot=imagecolorallocate($diagramm, 255, 0, 0);
  @imageline($diagramm, round($hoehe/2), round($breite/2), $radius_x1, $radius_y1, $schwarz);
  }
  
 $winkel+=$wert;
 $teil++;
 }


// Kreis zeichnen fuer neue GDlib
imagearc($diagramm, round($breite/2), round($hoehe/2), $breite, $hoehe, 1, 360, $schwarz);


header('Content-type: image/png');
imagepng($diagramm);
imagedestroy($diagramm);

// Hex in RGB umwandeln
function hex2rgb($hex)
 {
 $rgb[0]=hexdec(substr($hex,1,2));
 $rgb[1]=hexdec(substr($hex,3,2));
 $rgb[2]=hexdec(substr($hex,5,2));
 return($rgb);
 }

// Prozent-Funktion
function prozent($teil, $gesamt)
 {
 return @round($teil/$gesamt*100);
 }
?>